$(document).ready(function()
{
	//initialize();
});

function start_chat ()
{
	document.location.href = 'chat.php?start&name=' + encodeURIComponent ($('#name').val());
}

function send_message()
{
	message = $('#message').val();
	$('#message').val('').html('');
	if (message == '')
	{
		alert('Введите сообщение');
		return;
	}
	$.ajax(
	{
		type: 'POST',
		url: 'act.php',
		data: 'action=send_message&message=' + encodeURIComponent (message) + '&cid=' + encodeURIComponent ($('#cid').val()),
		success: function(res)
		{
			load_history();
		}
	});
}

function load_history()
{
	$.ajax(
	{
		type: 'POST',
		url: 'act.php',
		data: 'action=load_history&cid=' + encodeURIComponent ($('#cid').val()),
		success: function(res)
		{
			data = json_decode (res);
			$('#table_chat').html('');
			for (k in data['data'])
			{
				html = '<tr>';
				html += '<td style = "width: 15%">' + data['data'][k]['user'] + '</td>';
				html += '<td style = "width: 60%">' + data['data'][k]['message'] + '</td>';
				html += '<td style = "width: 20%">' + data['data'][k]['time'] + '</td>';
				html += '</tr>';
				$("#table_chat").append(html);
			}
			$('#users').html('');
			for (k in data['users'])
			{
				$('#users').append (data['users'][k]['user'] + '<br />');
			}
			
		}
	});
}

function join_chat()
{
	$.ajax(
	{
		type: 'POST',
		url: 'join.php',
		data: 'action=join&name=' + encodeURIComponent ($('#name').val()) + '&cid=' + encodeURIComponent ($('#cid').val()),
		success: function(res)
		{
			data = json_decode(res);
			if (data['success'] == '0')
			{
				alert (data['error']);
				return;
			} else {
				document.locatin.reload();
			}
		}
	});
}

function initialize()
{
	$('#editor').add('#save_del').slideToggle(0);
	upload_button = $('#upload_button');
	$.ajax_upload(upload_button, {
             action : 'upload.php',
             name : 'file',
             onSubmit : function(file, ext) {
               this.disable();
			   document.cookie = 'delimiter=' + encodeURIComponent ($('#delimiter').val());
			   document.cookie = 'charset=' + encodeURIComponent ($('#charset').val());
             },
             onComplete : function(file, response) {
				this.enable();
                res = json_decode (response);
			   if (res['success'] != '1') alert('Ошибка');
               else
               {
				res = json_decode (response);
				$('#table_edit tbody').html('');
				for (k in res['data'])
				{
					tr = $('<tr />');
					for (k2 in res['data'][k])
					{
						td = $('<td />');
						input = $('<input />', {
											value: res['data'][k][k2]
								});
						$(td).append(input);
						$(tr).append(td);
					}
					$('#table_edit tbody').append(tr);
				}
				if ($('#editor').is(':visible') == false) $('#editor').slideToggle('slow');
               }
             }
   	});
	
	var fixHelper = function(e, ui) 
	{
		ui.children().each(function() 
		{
			$(this).width($(this).width());
		});
    return ui;
	};

	$("#table_edit tbody").sortable({

		helper: fixHelper

	}).disableSelection();
}

function download_file()
{
	post = new Array();
	$('#table_edit').find('tr').each(function(k)
	{
		post[k] = new Array();
		$(this).find('td').each(function(k2)
		{
			post[k][k2] = $(this).find('input:first').val();
		});
	});
	delimiter = $('#delimiter').val();
	$.ajax({
		type: 'POST',
		data: 'data=' + encodeURIComponent (JSON.stringify(post)) + '&delimiter=' + encodeURIComponent (delimiter),
		url: 'download.php',
		success: function(res)
		{
			document.location.href = res;
		}
	});
}

function clear_file()
{
	$('#editor').slideToggle('slow');
}

function print_r(arr, level) {
    var print_red_text = "";
    if(!level) level = 0;
    var level_padding = "";
    for(var j=0; j<level+1; j++) level_padding += "    ";
    if(typeof(arr) == 'object') {
        for(var item in arr) {
            var value = arr[item];
            if(typeof(value) == 'object') {
                print_red_text += level_padding + "'" + item + "' :\n";
                print_red_text += print_r(value,level+1);
		} 
            else 
                print_red_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
        }
    } 

    else  print_red_text = "===>"+arr+"<===("+typeof(arr)+")";
    return print_red_text;
}

function json_decode (str_json) {
    // http://kevin.vanzonneveld.net
    // +      original by: Public Domain (http://www.json.org/json2.js)
    // + reimplemented by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      improved by: T.J. Leahy
    // +      improved by: Michael White
    // *        example 1: json_decode('[\n    "e",\n    {\n    "pluribus": "unum"\n}\n]');
    // *        returns 1: ['e', {pluribus: 'unum'}]
/*
        http://www.JSON.org/json2.js
        2008-11-19
        Public Domain.
        NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.
        See http://www.JSON.org/js.html
    */

    var json = this.window.JSON;
    if (typeof json === 'object' && typeof json.parse === 'function') {
        try {
            return json.parse(str_json);
        } catch (err) {
            if (!(err instanceof SyntaxError)) {
                throw new Error('Unexpected error type in json_decode()');
            }
            this.php_js = this.php_js || {};
            this.php_js.last_error_json = 4; // usable by json_last_error()
            return null;
        }
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
    var j;
    var text = str_json;

    // Parsing happens in four stages. In the first stage, we replace certain
    // Unicode characters with escape sequences. JavaScript handles many characters
    // incorrectly, either silently deleting them, or treating them as line endings.
    cx.lastIndex = 0;
    if (cx.test(text)) {
        text = text.replace(cx, function (a) {
            return '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        });
    }

    // In the second stage, we run the text against regular expressions that look
    // for non-JSON patterns. We are especially concerned with '()' and 'new'
    // because they can cause invocation, and '=' because it can cause mutation.
    // But just to be safe, we want to reject all unexpected forms.
    // We split the second stage into 4 regexp operations in order to work around
    // crippling inefficiencies in IE's and Safari's regexp engines. First we
    // replace the JSON backslash pairs with '@' (a non-JSON character). Second, we
    // replace all simple value tokens with ']' characters. Third, we delete all
    // open brackets that follow a colon or comma or that begin the text. Finally,
    // we look to see that the remaining characters are only whitespace or ']' or
    // ',' or ':' or '{' or '}'. If that is so, then the text is safe for eval.
    if ((/^[\],:{}\s]*$/).
    test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@').
    replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').
    replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {

        // In the third stage we use the eval function to compile the text into a
        // JavaScript structure. The '{' operator is subject to a syntactic ambiguity
        // in JavaScript: it can begin a block or an object literal. We wrap the text
        // in parens to eliminate the ambiguity.
        j = eval('(' + text + ')');

        return j;
    }

    this.php_js = this.php_js || {};
    this.php_js.last_error_json = 4; // usable by json_last_error()
    return null;
}